
u32 TextRealizeLine; // ۏ؂łs(0xffff=o)
u32 TextPageCache[0x100];
u32 TextCurrentPage;
u32 TextCurrentPageCache[0x101]; // [ô߈s߂

void Text_InitTextPageCache(void)
{
  TextRealizeLine=0xffff;
  
  u32 page;
  for(page=0;page<0x100;page++){
    TextPageCache[page]=-1;
  }
  
  TextCurrentPage=-1;

  u32 line;
  for(line=0;line<0x100;line++){
    TextCurrentPageCache[line]=-1;
  }
}

attriwram void farcall_Text_CalcTextPageCache(u32 page,u32 MaxLength)
{
  if(page==0){
    TextPageCache[page]=0;
    return;
  }
  if(TextPageCache[page]!=-1) return;

  if(TextPageCache[page-1]==-1){
    TextPageCache[page]=-1;
    return;
  }

  u8 *TextPtr;
  u32 TextCnt;
  u8 ch;
  u32 x;
  u32 line;
  
  TextPtr=&TextData[0];
  TextCnt=TextPageCache[page-1];
  line=0;
  x=0;
  
  while(1){
    ch=TextPtr[TextCnt];
    if(ch==0x0d){
      if(TextPtr[TextCnt+1]==0x0a){
        TextCnt+=2;
        }else{
        TextCnt+=1;
      }
      if(TextCnt>=TextDataSize){
        TextPageCache[page]=-1;
        return;
      }
      x=0;
      if(line==0xff) break;
      line++;
      }else{
      if(isAnkChar[ch]==True){
        TextCnt++;
        x++;
        }else{
        TextCnt+=2;
        x+=2;
      }
      if(x>=MaxLength){
        if(TextCnt>=TextDataSize){
          TextPageCache[page]=-1;
          return;
        }
        x=0;
        if(line==0xff) break;
        line++;
      }
    }
  }
  
  TextPageCache[page]=TextCnt;
}
void (*Text_CalcTextPageCache)(u32 page,u32 MaxLength)=&farcall_Text_CalcTextPageCache;

attriwram void farcall_Text_RefreshTextCurrentPageCache(u32 page,u32 MaxLength)
{
  if(TextCurrentPage==page) return;
  TextCurrentPage=page;
  
  u32 line;
  for(line=0;line<0x100;line++){
    TextCurrentPageCache[line]=-1;
  }
  
  if(page==-1) return;
  
  u32 ofs=TextPageCache[page];
  if(ofs==-1){
    Text_CalcTextPageCache(page,MaxLength);
    ofs=TextPageCache[page];
    if(ofs==-1) return;
  }
  
  u8 *TextPtr=(u8*)&TextData[ofs];
  u32 TextCnt;
  u8 ch;
  u32 x;
  
  TextPtr=&TextData[0];
  TextCnt=ofs;
  TextCurrentPageCache[0]=TextCnt;
  line=1;
  x=0;
  
  while(1){
    ch=TextPtr[TextCnt];
    if(ch==0x0d){
      if(TextPtr[TextCnt+1]==0x0a){
        TextCnt+=2;
        }else{
        TextCnt+=1;
      }
      if(TextCnt>=TextDataSize){
        TextRealizeLine=(page*0x100)+line;
        return;
      }
      TextCurrentPageCache[line]=TextCnt;
      if(line==0x100) break;
      line++;
      x=0;
      }else{
      if(isAnkChar[ch]==True){
        TextCnt++;
        x++;
        }else{
        TextCnt+=2;
        x+=2;
      }
      if(x>=MaxLength){
        if(TextCnt>=TextDataSize){
          TextRealizeLine=(page*0x100)+line;
          return;
        }
        TextCurrentPageCache[line]=TextCnt;
        if(line==0x100) break;
        line++;
        x=0;
      }
    }
  }
}
void (*Text_RefreshTextCurrentPageCache)(u32 page,u32 MaxLength)=&farcall_Text_RefreshTextCurrentPageCache;

u32 Text_GetLinePosition(u32 line,u32 MaxLength)
{
  Text_RefreshTextCurrentPageCache(line>>8,MaxLength);
  return(TextCurrentPageCache[line&0xff]);
}

u32 Text_SeekByteToLine(u32 Position,u32 MaxLength)
{
  if((TextDataSize-2)<=Position){
    Position=(TextDataSize-2)-1;
  }
  
  u32 line,pos;
  line=0;
  pos=0;
  while(pos<=Position){
    line++;
    pos=Text_GetLinePosition(line,MaxLength);
  }
  if(line!=0) line--;
  return(line);
}
