unit LoadBMWin;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, ComCtrls, StdCtrls, ExtCtrls,SpiBMP,NkDib,_PicTools;

type
  TLoadBM = class(TForm)
    PrvImg: TImage;
    GroupBox1: TGroupBox;
    ZoomWidthBtn: TButton;
    ZoomHeightBtn: TButton;
    Zoom100Btn: TButton;
    ZoomSizeLbl: TLabel;
    ZoomManBtn: TButton;
    GroupBox2: TGroupBox;
    PosLbl: TLabel;
    Zoom50Btn: TButton;
    BitBtn1: TBitBtn;
    BitBtn3: TBitBtn;
    PosInitBtn: TButton;
    PrvPalImg: TImage;
    ReduceTimer: TTimer;
    GroupBox3: TGroupBox;
    ReduceTypeLst: TComboBox;
    TileModeChk: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure ZoomWidthBtnClick(Sender: TObject);
    procedure ZoomHeightBtnClick(Sender: TObject);
    procedure Zoom100BtnClick(Sender: TObject);
    procedure Zoom50BtnClick(Sender: TObject);
    procedure PosInitBtnClick(Sender: TObject);
    procedure PrvImgMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PrvImgMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PrvImgMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ZoomManBtnClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure ReduceTimerTimer(Sender: TObject);
    procedure ReduceTypeLstChange(Sender: TObject);
    procedure TileModeChkClick(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    srcdib,dstdib:TNkDib;
    ZoomSize:double;
    PosX,PosY:integer;
    procedure Startup(Filename:string);
    procedure RefreshParam;
    procedure RefreshBM;
  end;

var
  LoadBM: TLoadBM;

implementation

{$R *.dfm}

uses MedianCut;

procedure ReduceDib(var dib:TNkDib;typ:integer);
var
  bm24,bm4:TBitmap;
  x,y:integer;
  pbm:PByteArray;
  transpal:integer;
  procedure ClearPalette;
  var
    palcnt:integer;
  begin
    for palcnt:=0 to 16-1 do begin
      dib.Colors[palcnt]:=0;
    end;
  end;
  procedure ReverseColors;
  var
    dib1:TNkDib;
    x,y:integer;
    pbm0,pbm1:PByteArray;
    palcnt:integer;
  begin
    dib1:=TNkDib.Create;
    dib1.PixelFormat:=nkpf8bit;
    dib1.Width:=240;
    dib1.Height:=160;

    for y:=0 to 160-1 do begin
      pbm0:=dib.ScanLine[y];
      pbm1:=dib1.ScanLine[y];
      for x:=0 to 240-1 do begin
        if pbm0[x]<16 then pbm1[x]:=15-pbm0[x];
      end;
    end;
    for palcnt:=0 to 16-1 do begin
      dib1.Colors[palcnt]:=dib.Colors[16-1-palcnt];
    end;

    dib1.AssignTo(dib);
    dib1.Free;
  end;
  function CalcPalLen(rgb0,rgb1:TRGB):integer;
  begin
    Result:=0;
    Result:=Result+abs(integer(rgb0.r)-integer(rgb1.r));
    Result:=Result+abs(integer(rgb0.g)-integer(rgb1.g));
    Result:=Result+abs(integer(rgb0.b)-integer(rgb1.b));
  end;
  function SeekNeerPalette(rgb:TRGB):integer;
  var
    rgb0,rgbt:TRGB;
    transpal:integer;
    pallen,paltmp:integer;
    palcnt:integer;
  begin
    rgb0:=dword2RGB(dib.Colors[0]);
    dib.Colors[0]:=0;

    pallen:=256*3;
    transpal:=0;
    for palcnt:=0 to 16-1 do begin
      rgbt:=dword2RGB(dib.Colors[palcnt]);
      paltmp:=CalcPalLen(rgb0,rgbt);
      if (paltmp<>0) and (pallen>paltmp) then begin
        pallen:=paltmp;
        transpal:=palcnt;
      end;
    end;

    Result:=transpal;
  end;
begin
  if dib.PixelFormat=nkpf8bit then exit;

  if dib.PixelFormat=nkpf24bit then ClearPalette;

  bm24:=TBitmap.Create;
  bm4:=TBitmap.Create;

  case typ of
    0: begin
      dib.AssignTo(bm24);
      bm4:=ReduceColorsByMedianCut(bm24,4);
      dib.Assign(bm4);
    end;
    1: begin
      dib.AssignTo(bm24);
      bm4:=ReduceColorsByMedianCutV(bm24,4);
      dib.Assign(bm4);
    end;
    2: begin
      dib.AssignTo(bm24);
      bm4:=ReduceColorsByMedianCutED(bm24,4);
      dib.Assign(bm4);
    end;
    3: begin
      dib.AssignTo(bm24);
      bm4:=ReduceColorsByMedianCutVED(bm24,4);
      dib.Assign(bm4);
    end;
    4: begin
      dib.ConvertMode:=nkCmNormal;
      dib.PixelFormat:=NkPf4bit;
      dib.PixelFormat:=NkPf8bit;
    end;
    5: begin
      dib.ConvertMode:=nkCmFine;
      dib.PixelFormat:=NkPf4bit;
      dib.PixelFormat:=NkPf8bit;
    end;
    else showmessage('sȌF^Cvw肳܂B');
  end;

  bm24.Free;
  bm4.Free;

  ReverseColors;

  transpal:=SeekNeerPalette(dword2RGB(dib.Colors[0]));
  dib.Colors[0]:=0;

  for y:=0 to 160-1 do begin
    pbm:=dib.ScanLine[y];
    for x:=0 to 240-1 do begin
      if pbm[x]=0 then pbm[x]:=transpal;
    end;
  end;
end;

procedure TLoadBM.FormCreate(Sender: TObject);
begin
  ZoomSize:=1;
  PosX:=0;
  PosY:=0;

  srcdib:=TNkDib.Create;
  dstdib:=TNkDib.Create;

  dstdib.Width:=240;
  dstdib.Height:=160;
end;

procedure TLoadBM.Startup(Filename:string);
var
  mstbm:TSPIBitmap;
begin
  if lowercase(ExtractFileExt(Filename))<>'.bmp' then begin
    mstbm:=TSPIBitmap.Create;
    mstbm.LoadFromFile(Filename);
    srcdib.Assign(mstbm);
    mstbm.Free;
    end else begin
    srcdib.LoadFromFile(Filename);
  end;
  srcdib.PixelFormat:=nkpf24bit;

  RefreshBM;
end;

procedure TLoadBM.RefreshParam;
begin
  ZoomSizeLbl.Caption:=format('g嗦 %7.3f%%',[ZoomSize*100]);
  PosLbl.Caption:=format('ړ=(%d,%d)',[PosX,PosY]);
  RefreshBM;
end;

procedure TLoadBM.RefreshBM;
var
  srcdibc,dstdibc:TNkDIBCanvas;
  sx,sy:integer;
  dx,dy:integer;
  px,py:integer;
  tsx,tsy,tex,tey:integer;
  tx,ty:integer;
begin
  dstdib.PixelFormat:=nkpf24bit;

  sx:=srcdib.Width;
  sy:=srcdib.Height;
  dx:=trunc(sx*ZoomSize);
  dy:=trunc(sy*ZoomSize);
  px:=PosX;
  py:=PosY;

  if dx<=0 then dx:=1;
  if dy<=0 then dy:=1;

  if TileModeChk.Checked=False then begin
    tsx:=0;
    tex:=1;
    tsy:=0;
    tey:=1;
    end else begin
    if px<=0 then begin
      tsx:=0;
      end else begin
      tsx:=-(trunc(px/dx)+1);
    end;
    if py<=0 then begin
      tsy:=0;
      end else begin
      tsy:=-(trunc(py/dy)+1);
    end;
    tex:=trunc((-px+240)/dx)+1;
    tey:=trunc((-py+160)/dy)+1;
  end;

  srcdibc:=TNkDIBCanvas.Create(srcdib);
  dstdibc:=TNkDIBCanvas.Create(dstdib);

  dstdibc.Brush.Color:=$000000;
  dstdibc.FillRect(Rect(0,0,240,160));

  SetStretchBltMode(srcdibc.Handle,HALFTONE);
  SetStretchBltMode(dstdibc.Handle,HALFTONE);
  for ty:=tsy to tey-1 do begin
    for tx:=tsx to tex-1 do begin
      StretchBlt(dstdibc.Handle,px+(dx*tx),py+(dy*ty),dx,dy,srcdibc.Handle,0,0,sx,sy,SRCCOPY);
    end;
  end;

  srcdibc.Free;
  dstdibc.Free;

  dstdib.AssignTo(PrvImg.Picture.Bitmap);
  PrvImg.Refresh;

  ReduceTimer.Enabled:=True;
end;

procedure TLoadBM.ZoomWidthBtnClick(Sender: TObject);
begin
  ZoomSize:=240/srcdib.Width;
  RefreshParam;
end;

procedure TLoadBM.ZoomHeightBtnClick(Sender: TObject);
begin
  ZoomSize:=160/srcdib.Height;
  RefreshParam;
end;

procedure TLoadBM.Zoom100BtnClick(Sender: TObject);
begin
  ZoomSize:=1;
  RefreshParam;
end;

procedure TLoadBM.Zoom50BtnClick(Sender: TObject);
begin
  ZoomSize:=0.5;
  RefreshParam;
end;

procedure TLoadBM.ZoomManBtnClick(Sender: TObject);
var
  str:string;
begin
  str:=format('%3.10f',[ZoomSize*100]);

  str:=InputBox('g嗦͂ĂB','',str);

  ZoomSize:=strtofloatdef(str,ZoomSize*100)/100;
  RefreshParam;
end;

procedure TLoadBM.PosInitBtnClick(Sender: TObject);
begin
  PosX:=0;
  PosY:=0;
  RefreshParam;
end;

var
  mf:boolean;
  mx,my:integer;

procedure TLoadBM.PrvImgMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button=mbLeft then mf:=True;

  mx:=X;
  my:=Y;
end;

procedure TLoadBM.PrvImgMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if mf=True then begin
    PosX:=PosX+(X-mx);
    PosY:=PosY+(Y-my);
    RefreshParam;
  end;

  mx:=X;
  my:=Y;
end;

procedure TLoadBM.PrvImgMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  mf:=False;
end;

procedure TLoadBM.BitBtn1Click(Sender: TObject);
var
  bm:TBitmap;
begin
  ReduceDib(dstdib,ReduceTypeLst.ItemIndex);

  bm:=TBitmap.Create;
  dstdib.AssignTo(bm);
  bm.Width:=256;
  bm.Height:=160;
  dstdib.Assign(bm);
  bm.Free;
end;

procedure TLoadBM.ReduceTimerTimer(Sender: TObject);
var
  palcnt:integer;
begin
  ReduceTimer.Enabled:=False;

  ReduceDib(dstdib,ReduceTypeLst.ItemIndex);
  dstdib.AssignTo(PrvImg.Picture.Bitmap);
  PrvImg.Refresh;
  
  MakeBlankImg(PrvPalImg,pf24bit);
  for palcnt:=0 to dstdib.PaletteSize-1 do begin
    PrvPalImg.Canvas.Brush.Color:=dstdib.Colors[palcnt];
    PrvPalImg.Canvas.FillRect(Bounds(palcnt*15,0,15,16));
  end;
  PrvPalImg.Refresh;
end;

procedure TLoadBM.ReduceTypeLstChange(Sender: TObject);
begin
  RefreshBM;
end;

procedure TLoadBM.TileModeChkClick(Sender: TObject);
begin
  RefreshBM;
end;

end.
