unit MainWin;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, ShellAPI,
  Dialogs,_m_Tools,_PicTools, StdCtrls, ComCtrls, Menus, ExtCtrls, SPIBmp,NkDIB,
  SPIs;

const CRLF=chr(13)+chr(10);

type
  TBGBM=record
    dummy:array[0..2] of byte;
    BlendType:dword;
    TextAlpha,BGAlpha:dword;
    nkbm:TNkDIB;
    GBABM:array[0..128*160] of byte;
  end;

type
  TMain = class(TForm)
    lst: TListBox;
    StatusBar1: TStatusBar;
    MainMenu1: TMainMenu;
    FileF1: TMenuItem;
    AboutA1: TMenuItem;
    OpenGBABINO1: TMenuItem;
    SaveGBABINS1: TMenuItem;
    Saveas1: TMenuItem;
    N1: TMenuItem;
    Exitx1: TMenuItem;
    OpenDlg: TOpenDialog;
    SaveDlg: TOpenDialog;
    N2: TMenuItem;
    GroupBox1: TGroupBox;
    ppTextChk: TCheckBox;
    ppSystemChk: TCheckBox;
    ppBGChk: TCheckBox;
    PrvTextImg: TImage;
    PrvSystemImg: TImage;
    Timer1: TTimer;
    hemeT1: TMenuItem;
    ext1: TMenuItem;
    ext5: TMenuItem;
    System1: TMenuItem;
    System2: TMenuItem;
    ppEmuGBAChk: TCheckBox;
    SPIs: TSPIs;
    PrvImg: TImage;
    GroupBox2: TGroupBox;
    TextAlphaLbl: TLabel;
    BGAlphaLbl: TLabel;
    Label1: TLabel;
    BGAlphaBar: TTrackBar;
    TextAlphaBar: TTrackBar;
    BlendTypeLst: TComboBox;
    BGImg: TImage;
    BGPalImg: TImage;
    OpenBGDlg: TOpenDialog;
    ImportBMPI1: TMenuItem;
    N3: TMenuItem;
    Label2: TLabel;
    procedure WMDROPFILES(var msg:TWMDROPFILES);message WM_DROPFILES;
    procedure FormCreate(Sender: TObject);
    procedure lstDblClick(Sender: TObject);
    procedure lstDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure AboutA1Click(Sender: TObject);
    procedure OpenGBABINO1Click(Sender: TObject);
    procedure SaveGBABINS1Click(Sender: TObject);
    procedure Saveas1Click(Sender: TObject);
    procedure Exitx1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure AlphaBarChange(Sender: TObject);
    procedure BlendTypeLstChange(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure ppChkClick(Sender: TObject);
    procedure ext1Click(Sender: TObject);
    procedure ext5Click(Sender: TObject);
    procedure System1Click(Sender: TObject);
    procedure System2Click(Sender: TObject);
    procedure ImportBMPI1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    RGBTable:TRGBArray;
    BGBM:TBGBM;
  end;

var
  Main: TMain;

implementation

uses ColorPickWin, AboutWin, LoadBMWin, OnlineHelpWin;

{$R *.dfm}

const RGBTableCount=7;
const RGBTable_TextBG=0;
const RGBTable_TextChar=1;
const RGBTable_TabChar=2;
const RGBTable_SystemBG=3;
const RGBTable_SystemText=4;
const RGBTable_FrameBright=5;
const RGBTable_FrameMask=6;

// ---------------------------------------------------------------------

procedure BGBM_nkbm2GBABM(var BGBM:TBGBM);
var
  x,y:integer;
  tx,ty:integer;
  pos:integer;
  procedure AddTile(x,y:integer);
  var
    tx,ty:integer;
  begin
    for ty:=0 to 8-1 do begin
      for tx:=0 to 4-1 do begin
        BGBM.GBABM[pos]:=(BGBM.nkbm.Pixels[x+(tx*2+1),y+ty] shl 4)+BGBM.nkbm.Pixels[x+(tx*2+0),y+ty];
        inc(pos);
      end;
    end;
  end;
begin
  pos:=0;

  for y:=0 to (160 div 32)-1 do begin
    for x:=0 to (256 div 32)-1 do begin
      for ty:=0 to 4-1 do begin
        for tx:=0 to 4-1 do begin
          AddTile((x*32)+tx*8,(y*32)+ty*8);
        end;
      end;
    end;
  end;
end;

procedure BGBM_GBABM2nkbm(var BGBM:TBGBM);
var
  x,y:integer;
  tx,ty:integer;
  pos:integer;
  procedure GetTile(x,y:integer);
  var
    tx,ty:integer;
  begin
    for ty:=0 to 8-1 do begin
      for tx:=0 to 4-1 do begin
        BGBM.nkbm.Pixels[x+(tx*2+1),y+ty]:=BGBM.GBABM[pos] shr 4 and $0f;
        BGBM.nkbm.Pixels[x+(tx*2+0),y+ty]:=BGBM.GBABM[pos] shr 0 and $0f;
        inc(pos);
      end;
    end;
  end;
begin
  pos:=0;

  for y:=0 to (160 div 32)-1 do begin
    for x:=0 to (256 div 32)-1 do begin
      for ty:=0 to 4-1 do begin
        for tx:=0 to 4-1 do begin
          GetTile((x*32)+tx*8,(y*32)+ty*8);
        end;
      end;
    end;
  end;
end;

// ---------------------------------------------------------------------

function SeekID(var rfs:TFileStream;ID:string):boolean;
var
  cbuf:array[0..6] of char;
  i:integer;
  rbufcount:integer;
  rbuf:array[0..256*1024] of char;
begin
  for i:=0 to 6-1 do begin
    cbuf[i]:=ID[i+1];
  end;

  rbufcount:=rfs.Size;
  if rbufcount>256*1024 then rbufcount:=256*1024;

  rfs.Position:=0;
  rfs.ReadBuffer(rbuf[0],rbufcount);

  i:=0;

  while(i<(rbufcount-6)) do begin
    if rbuf[i+0]=cbuf[0] then begin
      if ((rbuf[i+1]=cbuf[1]) and (rbuf[i+2]=cbuf[2]) and (rbuf[i+3]=cbuf[3]) and (rbuf[i+4]=cbuf[4]) and (rbuf[i+5]=cbuf[5])) then begin
        rfs.Position:=i+6;
        Result:=True;
        exit;
      end;
    end;
    inc(i);
  end;

  Result:=False;
end;

// --------------------------------------------------------

function LoadRGBTableFromBIN(binfn:string;var RGBTable:TRGBArray):boolean;
var
  rfs:TFileStream;
begin
  if FileExists(binfn)=False then begin
    ShowMessage('t@C['+binfn+']܂łB');
    Result:=False;
    exit;
  end;

  rfs:=TFileStream.Create(binfn,fmOpenRead);

  if SeekID(rfs,'RGBC02')=False then begin
    rfs.Free;
    ShowMessage('RGBCID܂łB'+CRLF+'J[JX^}CYΉps2txtł̃G[\ꍇ́A'+CRLF+'Moonlight܂ŕ񍐒Ƃ肪łB');
    Result:=False;
    exit;
  end;

  rfs.ReadBuffer(RGBTable[0].b,RGBTableCount*3);

  rfs.Free;

  Result:=True;
end;

function SaveRGBTableToBIN(binfn:string;var RGBTable:TRGBArray):boolean;
var
  wfs:TFileStream;
begin
  if FileExists(binfn)=False then begin
    ShowMessage('t@C['+binfn+']܂łB');
    Result:=False;
    exit;
  end;

  wfs:=TFileStream.Create(binfn,fmOpenReadWrite);

  if SeekID(wfs,'RGBC02')=False then begin
    wfs.Free;
    ShowMessage('RGBCID܂łB'+CRLF+'J[JX^}CYΉps2txtł̃G[\ꍇ́A'+CRLF+'Moonlight܂ŕ񍐒Ƃ肪łB');
    Result:=False;
    exit;
  end;

  wfs.WriteBuffer(RGBTable[0].b,RGBTableCount*3);

  wfs.Free;

  Result:=True;
end;

// -------------------------------------------------------------------

function LoadBGBMFromBIN(binfn:string;var BGBM:TBGBM):boolean;
var
  rfs:TFileStream;
  pal:integer;
  r,g,b:byte;
begin
  if FileExists(binfn)=False then begin
    ShowMessage('t@C['+binfn+']܂łB');
    Result:=False;
    exit;
  end;

  rfs:=TFileStream.Create(binfn,fmOpenRead);

  if SeekID(rfs,'BGBM01')=False then begin
    rfs.Free;
    ShowMessage('BGBMID܂łB'+CRLF+'wiΉps2txtł̃G[\ꍇ́A'+CRLF+'Moonlight܂ŕ񍐒Ƃ肪łB');
    Result:=False;
    exit;
  end;

  rfs.ReadBuffer(BGBM.dummy[0],2);
  rfs.ReadBuffer(BGBM.BlendType,4);
  rfs.ReadBuffer(BGBM.TextAlpha,4);
  rfs.ReadBuffer(BGBM.BGAlpha,4);

  BGBM.nkbm.BitCount:=8;
  BGBM.nkbm.Width:=256;
  BGBM.nkbm.Height:=160;

  for pal:=0 to 16-1 do begin
    rfs.ReadBuffer(b,1);
    rfs.ReadBuffer(g,1);
    rfs.ReadBuffer(r,1);
    BGBM.nkbm.Colors[pal]:=(b shl 3 shl 16)+(g shl 3 shl 8)+(r shl 3 shl 0);
  end;

  rfs.ReadBuffer(BGBM.GBABM[0],128*160);
  BGBM_GBABM2nkbm(BGBM);

  rfs.Free;

  Result:=True;
end;

function SaveBGBMToBIN(binfn:string;var BGBM:TBGBM):boolean;
var
  wfs:TFileStream;
  pal:integer;
  r,g,b:byte;
begin
  if FileExists(binfn)=False then begin
    ShowMessage('t@C['+binfn+']܂łB');
    Result:=False;
    exit;
  end;

  wfs:=TFileStream.Create(binfn,fmOpenReadWrite);

  if SeekID(wfs,'BGBM01'+chr(0)+chr(0))=False then begin
    wfs.Free;
    ShowMessage('BGBMID܂łB'+CRLF+'wiΉps2txtł̃G[\ꍇ́A'+CRLF+'Moonlight܂ŕ񍐒Ƃ肪łB');
    Result:=False;
    exit;
  end;

  wfs.WriteBuffer(BGBM.dummy[0],2);
  wfs.WriteBuffer(BGBM.BlendType,4);
  wfs.WriteBuffer(BGBM.TextAlpha,4);
  wfs.WriteBuffer(BGBM.BGAlpha,4);

  for pal:=0 to 16-1 do begin
    b:=(BGBM.nkbm.Colors[pal] shr 16) and $ff shr 3;
    g:=(BGBM.nkbm.Colors[pal] shr 8) and $ff shr 3;
    r:=(BGBM.nkbm.Colors[pal] shr 0) and $ff shr 3;
    wfs.WriteBuffer(b,1);
    wfs.WriteBuffer(g,1);
    wfs.WriteBuffer(r,1);
  end;

  BGBM_nkbm2GBABM(BGBM);
  wfs.WriteBuffer(BGBM.GBABM[0],128*160);

  wfs.Free;

  Result:=True;
end;

procedure BGBMRefresh(var BGBM:TBGBM);
var
  x,y:integer;
  pal:array[0..255] of TRGB;
  palcnt:integer;
  s8a:PByteArray;
  d24a:PRGBArray;
  srcpal:byte;
  rgb0,rgb1:TRGB;
  alpha0,alpha1:integer;
  ir,ig,ib:integer;
  procedure palGBA2DIB;
  var
    palcnt:integer;
  begin
    for palcnt:=0 to 256-1 do begin
      with pal[palcnt] do begin
        r:=r shl 3;
        g:=g shl 3;
        b:=b shl 3;
      end;
    end;
  end;
begin
  Main.BlendTypeLst.OnChange:=nil;
  Main.TextAlphaBar.OnChange:=nil;
  Main.BGAlphaBar.OnChange:=nil;

  Main.BlendTypeLst.ItemIndex:=BGBM.BlendType;
  Main.TextAlphaBar.Position:=BGBM.TextAlpha;
  Main.BGAlphaBar.Position:=BGBM.BGAlpha;

  Main.BlendTypeLst.OnChange:=Main.BlendTypeLstChange;
  Main.TextAlphaBar.OnChange:=Main.AlphaBarChange;
  Main.BGAlphaBar.OnChange:=Main.AlphaBarChange;

  BGBM.nkbm.AssignTo(Main.BGImg.Picture.Bitmap);

  MakeBlankImg(Main.BGPalImg,pf24bit);
  for palcnt:=0 to BGBM.nkbm.PaletteSize-1 do begin
    Main.BGPalImg.Canvas.Brush.Color:=BGBM.nkbm.Colors[palcnt];
    Main.BGPalImg.Canvas.FillRect(Bounds(palcnt*15,0,15,16));
  end;

  MakeBlankImg(Main.PrvImg,pf24bit);

  if Main.ppTextChk.Checked=True then begin
    pal[0]:=dword2RGB(0);
    pal[1]:=Main.RGBTable[RGBTable_TextBG];
    pal[2]:=Main.RGBTable[RGBTable_TextChar];
    pal[3]:=Main.RGBTable[RGBTable_TabChar];
    palGBA2DIB;

    for y:=0 to 160-1 do begin
      s8a:=Main.PrvTextImg.Picture.Bitmap.ScanLine[y];
      d24a:=Main.PrvImg.Picture.Bitmap.ScanLine[y];
      for x:=0 to 240-1 do begin
        d24a[x]:=pal[s8a[x]];
      end;
    end;
  end;

  if (Main.ppBGChk.Checked=True) and (BGBM.nkbm<>nil) and (BGBM.BlendType=0) then begin
    for palcnt:=0 to 256-1 do begin
      pal[palcnt]:=dword2RGB(0);
    end;
    for palcnt:=0 to 16-1 do begin
      pal[palcnt]:=dword2RGB(BGBM.nkbm.Colors[palcnt]);
    end;

    alpha0:=BGBM.TextAlpha;
    alpha1:=BGBM.BGAlpha;

    for y:=0 to 160-1 do begin
      s8a:=BGBM.nkbm.ScanLine[y];
      d24a:=Main.PrvImg.Picture.Bitmap.ScanLine[y];
      for x:=0 to 240-1 do begin
        srcpal:=s8a[x];
        if srcpal<>0 then begin
          rgb0:=d24a[x];
          rgb1:=pal[srcpal];
          ir:=(integer(rgb0.r)*alpha0 div 16)+(integer(rgb1.r)*alpha1 div 16);
          ig:=(integer(rgb0.g)*alpha0 div 16)+(integer(rgb1.g)*alpha1 div 16);
          ib:=(integer(rgb0.b)*alpha0 div 16)+(integer(rgb1.b)*alpha1 div 16);
          if ir>$ff then begin
            rgb0.r:=$ff;
            end else begin
            rgb0.r:=byte(ir);
          end;
          if ig>$ff then begin
            rgb0.g:=$ff;
            end else begin
            rgb0.g:=byte(ig);
          end;
          if ib>$ff then begin
            rgb0.b:=$ff;
            end else begin
            rgb0.b:=byte(ib);
          end;
          d24a[x]:=rgb0;
        end;
      end;
    end;
  end;

  if Main.ppSystemChk.Checked=True then begin
    pal[0]:=dword2RGB(0);
    pal[1]:=dword2RGB(0);
    pal[2]:=Main.RGBTable[RGBTable_SystemBG];
    pal[3]:=Main.RGBTable[RGBTable_SystemText];
    pal[4]:=Main.RGBTable[RGBTable_FrameBright];
    pal[5]:=Main.RGBTable[RGBTable_FrameMask];
    palGBA2DIB;

    for y:=0 to 160-1 do begin
      s8a:=Main.PrvSystemImg.Picture.Bitmap.ScanLine[y];
      d24a:=Main.PrvImg.Picture.Bitmap.ScanLine[y];
      for x:=0 to 240-1 do begin
        if s8a[x]<>0 then d24a[x]:=pal[s8a[x]];
      end;
    end;
  end;

  if Main.ppEmuGBAChk.Checked=True then begin
    for y:=0 to 160-1 do begin
      d24a:=Main.PrvImg.Picture.Bitmap.ScanLine[y];
      for x:=0 to 240-1 do begin
        rgb0:=d24a[x];
        rgb0.r:=rgb0.r and $f8;
        rgb0.g:=rgb0.g and $f8;
        rgb0.b:=rgb0.b and $f8;
        d24a[x]:=rgb0;
      end;
    end;
  end;

  Main.PrvImg.Refresh;
end;

procedure LoadBGBMFromBMP(var BGBM:TBGBM;Filename:string);
begin
  LoadBM.Startup(Filename);
  if LoadBM.ShowModal=mrCancel then exit;

  BGBM.nkbm.Assign(LoadBM.dstdib);

  BGBMRefresh(BGBM);
end;

// --------------------------------------------------------------

procedure TMain.WMDROPFILES(var msg:TWMDROPFILES);
var
  Drop:hdrop;
  index:longint;
  Filename:string;
  filebuf:array[0..1024] of char;
  cnt:integer;
begin
  Filename:=StringOfChar(' ',1024);
  Drop:=msg.Drop;
  index:=DragQueryFile(Drop,$FFFFFFFF,nil,0);
  if index=0 then begin
    DragFinish(Drop);
    exit;
  end;

  if index>=2 then begin
    ShowMessage('t@C̃hbOAhhbv͖ΉłB');
    end else begin
    DragQueryFile(Drop,0,filebuf,1024);
    Filename:='';
    cnt:=0;
    while ((filebuf[cnt]<>char($00)) and (cnt<1024)) do begin
      Filename:=Filename+filebuf[cnt];
      inc(cnt);
    end;
    if Filename[Length(Filename)]<>'\' then begin
      if FileExists(Filename)=False then Filename:=Filename+'\';
    end;
    if Filename[Length(Filename)]='\' then begin
      if DirectoryExists(Filename)=False then Filename:='';
    end;
    if FileExists(Filename)=True then begin
      LoadBGBMFromBMP(BGBM,Filename);
    end;
  end;
  DragFinish(Drop);
end;

procedure TMain.FormCreate(Sender: TObject);
var
  cnt:integer;
begin
  DragAcceptFiles(Main.handle,True); // D&D Start
//  DragAcceptFiles(Main.handle,False); // D&D End

  for cnt:=0 to RGBTableCount-1 do begin
    RGBTable[cnt].b:=0;
    RGBTable[cnt].g:=0;
    RGBTable[cnt].r:=0;
  end;

  lst.ItemHeight:=lst.ItemHeight+2;

  lst.Clear;
  for cnt:=0 to RGBTableCount-1 do begin
    lst.Items.Add('');
  end;

  lst.Items[RGBTable_TextBG]:='TextBG';
  lst.Items[RGBTable_TextChar]:='TextChar';
  lst.Items[RGBTable_TabChar]:='TabChar';
  lst.Items[RGBTable_SystemBG]:='SystemBG';
  lst.Items[RGBTable_SystemText]:='SystemText';
  lst.Items[RGBTable_FrameBright]:='SystemFrameBright';
  lst.Items[RGBTable_FrameMask]:='SystemFrameMask';

  BlendTypeLst.Clear;
  BlendTypeLst.Items.Add('Type:0 F');
  BlendTypeLst.ItemIndex:=0;

  BGBM.nkbm:=TNkDIB.Create;
  BGBM.nkbm.PixelFormat:=nkpf8bit;
  BGBM.nkbm.Width:=256;
  BGBM.nkbm.Height:=160;

  MakeBlankImg(PrvImg,pf24bit);
  MakeBlankImg(BGImg,pf24bit);
  MakeBlankImg(BGPalImg,pf24bit);
end;

procedure TMain.lstDblClick(Sender: TObject);
var
  idx:integer;
  rgb:TRGB;
begin
  idx:=lst.ItemIndex;
  if (idx<0) or (RGBTableCount<=idx) then exit;

  rgb.b:=RGBTable[idx].b shl 3;
  rgb.g:=RGBTable[idx].g shl 3;
  rgb.r:=RGBTable[idx].r shl 3;

  ColorPick.Top:=Main.Top;
  ColorPick.Left:=Main.Left+Main.Width;

  ColorPick.StartPick((rgb.b shl 16)+(rgb.g shl 8)+rgb.r);
  if ColorPick.ShowModal=mrOK then begin
    rgb.b:=ColorPick.PickColor shr 16 and $ff;
    rgb.g:=ColorPick.PickColor shr 8 and $ff;
    rgb.r:=ColorPick.PickColor and $ff;
    RGBTable[idx].b:=rgb.b shr 3;
    RGBTable[idx].g:=rgb.g shr 3;
    RGBTable[idx].r:=rgb.r shr 3;
    lst.Refresh;
    BGBMRefresh(BGBM);
  end;
end;

procedure TMain.lstDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
  cm:string;
  c:dword;
	Offset:Integer;
  BoxY,TextY:integer;
begin
  if (Index<0) or (RGBTableCount<=Index) then exit;

  with (Control as TListBox).Canvas do begin
    with RGBTable[Index] do begin
      cm:='0x00'+inttohex(b shl 3,2)+inttohex(g shl 3,2)+inttohex(r shl 3,2)+' '+(Control as TListBox).Items[Index];
      c:=(b shl 3 shl 16)+(g shl 3 shl 8)+(r shl 3);
    end;

    FillRect(Rect);
    Offset:=2;
    BoxY:=Rect.Bottom-Rect.Top-2;
    TextY:=TextHeight('0');

    Brush.Style:=bsSolid;
    with Rect do begin
      Brush.Color:=$000000;
      FillRect(Bounds(Left+Offset+(BoxY div 4)-1,Top+(BoxY div 4)-1,(BoxY div 4)*2+2,(BoxY div 4)*2+2));
      Brush.Color:=c;
      FillRect(Bounds(Left+Offset+(BoxY div 4),Top+(BoxY div 4),(BoxY div 4)*2,(BoxY div 4)*2));
    end;
    inc(Offset,BoxY);

    Brush.Style:=bsClear;
    TextOut(Rect.Left+Offset,Rect.Top+((BoxY-TextY) div 2),cm);
  end;
end;

procedure TMain.AboutA1Click(Sender: TObject);
begin
  About.ShowModal;
end;

procedure TMain.OpenGBABINO1Click(Sender: TObject);
begin
  if OpenDlg.Execute=True then begin
    LoadRGBTableFromBIN(OpenDlg.Filename,RGBTable);
    lst.Refresh;
    LoadBGBMFromBIN(OpenDlg.Filename,BGBM);
    BGBMRefresh(BGBM);
    Main.BlendTypeLst.ItemIndex:=BGBM.BlendType;
    Main.TextAlphaLbl.Caption:='TextAlpha '+inttostr(BGBM.TextAlpha);
    Main.BGAlphaLbl.Caption:='BGAlpha '+inttostr(BGBM.BGAlpha);
  end;
end;

procedure TMain.SaveGBABINS1Click(Sender: TObject);
var
  msg:string;
begin
  if FileExists(OpenDlg.FileName)=False then begin
    ShowMessage('ROMt@C܂B'+CRLF+'SaveAsōđIɏނAROMt@CJĉB');
    exit;
  end;

  msg:='t@C['+OpenDlg.FileName+']ɐFł낵łH';

  if MessageDlg(msg,mtWarning,[mbYes,mbCancel],0)=mrYes then begin
    if SaveRGBTableToBIN(OpenDlg.Filename,RGBTable)=False then exit;
    if SaveBGBMToBIN(OpenDlg.Filename,BGBM)=False then exit;
    ShowMessage('ɏ݂I܂B');
  end;

end;

procedure TMain.Saveas1Click(Sender: TObject);
begin
  SaveDlg.FileName:=OpenDlg.FileName;

  if SaveDlg.Execute=True then begin
    OpenDlg.FileName:=SaveDlg.FileName;
    if SaveRGBTableToBIN(OpenDlg.Filename,RGBTable)=False then exit;
    if SaveBGBMToBIN(OpenDlg.Filename,BGBM)=False then exit;
    ShowMessage('ɏ݂I܂B');
  end;

end;

procedure TMain.Exitx1Click(Sender: TObject);
begin
  Main.Close;
end;

procedure TMain.N2Click(Sender: TObject);
begin
  OnlineHelp.Visible:=True;
end;

procedure TMain.AlphaBarChange(Sender: TObject);
begin
  BGBM.TextAlpha:=TextAlphaBar.Position;
  BGBM.BGAlpha:=BGAlphaBar.Position;

  TextAlphaLbl.Caption:='TextAlpha '+inttostr(BGBM.TextAlpha);
  BGAlphaLbl.Caption:='BGAlpha '+inttostr(BGBM.BGAlpha);

  BGBMRefresh(BGBM);
end;

procedure TMain.BlendTypeLstChange(Sender: TObject);
begin
  BGBM.BlendType:=BlendTypeLst.ItemIndex;
  BGBMRefresh(BGBM);
end;

procedure TMain.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled:=False;
  OpenGBABINO1Click(Sender);
  exit;
  
  OpenDlg.FileName:='C:\GBA\ps2_text\txt.bin';

  LoadRGBTableFromBIN(OpenDlg.Filename,RGBTable);
  lst.Refresh;
  LoadBGBMFromBIN(OpenDlg.Filename,BGBM);
  BGBMRefresh(BGBM);

  LoadBGBMFromBMP(BGBM,'pt_wl12.bmp');
end;

procedure TMain.ppChkClick(Sender: TObject);
begin
  BGBMRefresh(BGBM);
end;

procedure TMain.ext1Click(Sender: TObject);
begin
  RGBTable[RGBTable_TextBG]     :=RGB2RGB($1f,$1f,$1f);
  RGBTable[RGBTable_TextChar]   :=RGB2RGB($00,$00,$00);
  lst.Refresh;
  BGBMRefresh(BGBM);
end;

procedure TMain.ext5Click(Sender: TObject);
begin
  RGBTable[RGBTable_TextBG]     :=RGB2RGB($00,$00,$00);
  RGBTable[RGBTable_TextChar]   :=RGB2RGB($1f,$1f,$1f);
  lst.Refresh;
  BGBMRefresh(BGBM);
end;

procedure TMain.System1Click(Sender: TObject);
begin
  RGBTable[RGBTable_SystemBG]   :=RGB2RGB($1f,$1f,$1f);
  RGBTable[RGBTable_SystemText] :=RGB2RGB($00,$00,$00);
  RGBTable[RGBTable_FrameBright]:=RGB2RGB($0e,$0e,$0e);
  RGBTable[RGBTable_FrameMask]  :=RGB2RGB($15,$15,$15);
  lst.Refresh;
  BGBMRefresh(BGBM);
end;

procedure TMain.System2Click(Sender: TObject);
begin
  RGBTable[RGBTable_SystemBG]   :=RGB2RGB($00,$00,$00);
  RGBTable[RGBTable_SystemText] :=RGB2RGB($1f,$1f,$1f);
  RGBTable[RGBTable_FrameBright]:=RGB2RGB($0e,$0e,$0e);
  RGBTable[RGBTable_FrameMask]  :=RGB2RGB($15,$15,$15);
  lst.Refresh;
  BGBMRefresh(BGBM);
end;

procedure TMain.ImportBMPI1Click(Sender: TObject);
var
  extname,exttype:string;
  cnt,scnt:integer;
begin
  extname:='*.bmp';
  exttype:='bmp';
  OpenBGDlg.Filter:='WindowsBitmap (*.bmp)|*.bmp';

  for cnt:=0 to SPIs.Count-1 do begin
    for scnt:=0 to SPIs.Plugins[cnt].ExtNames.Count-1 do begin
      extname:=extname+';'+SPIs.Plugins[cnt].ExtNames[scnt];
      exttype:=exttype+'/'+SPIs.Plugins[cnt].FileTypes[scnt];
      OpenBGDlg.Filter:=OpenBGDlg.Filter+'|'+SPIs.Plugins[cnt].FileTypes[scnt]+' ('+SPIs.Plugins[cnt].ExtNames[scnt]+')|'+SPIs.Plugins[cnt].ExtNames[scnt];
    end;
  end;

  OpenBGDlg.Filter:='SupportAllFileTypes ('+exttype+')|'+extname+'|'+OpenBGDlg.Filter+'|AllFiles (*.*)|*.*';

  if OpenBGDlg.Execute=True then begin
    LoadBGBMFromBMP(BGBM,OpenBGDlg.Filename);
  end;
end;

end.
